﻿using Microsoft.AspNetCore.Mvc;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using System.Linq.Dynamic.Core;
using System;
using Microsoft.EntityFrameworkCore;
using Schedule.Models;
using System.Threading.Tasks;

namespace Schedule.Controllers
{
    public class HomeController : Controller
    {
        private NORTHWNDContext _context;
        public HomeController(NORTHWNDContext context)
        {
            _context = context;
        }

        //public IActionResult Index()
        //{
        //    return View();
        //}
        public async Task<IActionResult> Index()
        {
           // await _context.Orders.ToList();
           // return View();
            ViewBag.datasource = _context.Orders.Take(100).ToList();
            return View();
        }
        public List<Orders> GetData()
        {

            List<Orders> datas = _context.Orders.Take(100).ToList();
            return datas;
        }
       
        //public IActionResult DataSource([FromBody]Test dm)
        //{

        //    IEnumerable Result = _context.Orders.Take(100).ToList();
        //    var count = _context.Orders.AsQueryable().Count();
        //    DataOperations operation = new DataOperations();
        //    DataResult result = new DataResult();
        //    if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
        //    {
        //        Result = operation.PerformSorting(Result, dm.Sorted);
        //    }
        //    if (dm.Where != null && dm.Where.Count > 0) //Filtering
        //    {
        //        Result = operation.PerformWhereFilter(Result, dm.Where, dm.Where[0].Operator);
        //    }
        //    List<string> str = new List<string>();
          
        //    count = Result.AsQueryable().Count();
        //    if (dm.Skip != 0)
        //    {
        //        Result = operation.PerformSkip(Result, dm.Skip);
        //    }
        //    if (dm.Take != 0)
        //    {
        //        Result = operation.PerformTake(Result, dm.Take);
        //    }
        //    result.result = Result;
        //    result.count = count;
        //    return Json(result);

        //}
        //public class Test : DataManager
        //{
        //    public int age { get; set; }
        //}
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
            public IEnumerable aggregate { get; set; }
            public IEnumerable groupDs { get; set; }
        }

        public ActionResult CellEditInsert([FromBody]EditParams value)
        {
            var datas = _context;
            value.value.OrderID = _context.Orders.First().OrderID -1;
            datas.Orders.Add(value.value);
            datas.SaveChanges();
            return Json(value);


        }
        public ActionResult CellEditUpdate([FromBody]EditParams value)
        {
            var db = _context;
            db.Entry(value.value).State = EntityState.Modified;
            db.SaveChanges();
            return Json(value);

        }
        public ActionResult CellEditDelete([FromBody]EditParams value)
        {
            var db = _context;
            Orders order = db.Orders.Where(c => c.OrderID == Convert.ToInt32(value.key)).FirstOrDefault();
            db.Orders.Remove(order);
            db.SaveChanges();
            return Json(order);
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
